import {
	inject,
	observer,
} from 'mobx-react'
import {
	toJS
} from 'mobx'
import {
	WeaTop,
} from 'ecCom'
import {
	Modal,
	Button,
} from 'antd'
import {
	i18n
} from '../../public/i18n';
const confirm = Modal.confirm;

@inject('hrmSalaryItemsSet')
@observer
export default class Header extends React.Component {
	constructor(props) {
		super(props);
	}

	componentDidMount() {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			getButtonsMenu,
		} = hrmSalaryItemsSet;

		getButtonsMenu();
	}

	getTopMenuBtns = () => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			menu,
			mainTable,
		} = hrmSalaryItemsSet, {
			tableStore
		} = mainTable;

		let btns = [];

		const len = tableStore.selectedRowKeys.length;

		toJS(menu.topMenu).map((item, index) => {
			if (item.menuFun !== 'batchDelete') {
				btns.push(<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@zwth1s@${index}`} type='primary' disabled={tableStore.loading} onClick={() => this.handleClick(item)}>{item.menuName}</Button>);
			} else {
				btns.push(<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@oaugvp@${index}`} type='primary' disabled={len > 0 ? false : true} onClick={() => this.handleClick(item)}>{item.menuName}</Button>);
			}
		});
		return btns;
	}

	handleClick = (item) => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			searchPanel,
			changeSearchPanelStatus
		} = hrmSalaryItemsSet, {
			isPanelShow
		} = searchPanel;

		isPanelShow && changeSearchPanelStatus(false);
		this[item.menuFun] && this[item.menuFun]()
	}

	getDropMenuDatas = () => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			menu,
			mainTable,
		} = hrmSalaryItemsSet, {
			rightMenu
		} = menu;

		const len = mainTable.tableStore.selectedRowKeys.length;

		let menus = [];
		toJS(rightMenu).map((item, index) => {
			let obj = {
				key: item.menuFun,
				icon: <i className={`${item.menuIcon}`}/>,
				content: item.menuName,
			}
			if (item.menuFun == 'collection' || item.menuFun == 'help' || item.menuFun == 'pageAddress') {
				obj.disabled = true;
			}

			if (item.menuFun == 'batchDelete') {
				obj.disabled = len > 0 ? false : true;
			}
			menus.push(obj);
		})

		return menus;
	}

	handleMenuClick = (key) => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			searchPanel,
			changeSearchPanelStatus
		} = hrmSalaryItemsSet, {
			isPanelShow
		} = searchPanel;

		isPanelShow && changeSearchPanelStatus(false);
		this[key] && this[key]();
	}

	log = () => {
		window.setLogViewProps({
			logSmallType: '3030',
		});
	}

	new = () => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			openDialog,
		} = hrmSalaryItemsSet

		openDialog();
	}

	batchDelete() {
		this.showConfirm();
	}

	custom = () => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			mainTable,
		} = hrmSalaryItemsSet, {
			tableStore
		} = mainTable;

		tableStore.setColSetVisible(true);
		tableStore.tableColSet(true);
	}

	showConfirm = () => {
		let _this = this;
		confirm({
			title: i18n.confirm.defaultTitle(),
			content: i18n.confirm.batchDeleteConfirm(),
			okText: i18n.button.ok(),
			cancelText: i18n.button.cancel(),
			onOk() {
				_this.onOk()
			},
			onCancel() {
				return false
			},
		});
	}

	onOk = () => {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			deleteTableInfo,
		} = hrmSalaryItemsSet;

		deleteTableInfo();
	}

	render() {
		const {
			hrmSalaryItemsSet
		} = this.props, {
			main
		} = hrmSalaryItemsSet, {
			title,
		} = main;

		return (
			<WeaTop ecId={`${this && this.props && this.props.ecId || ''}_WeaTop@hhsq8b`} 
				title={title}
				icon={<i className='icon-coms-hrm'/>}
				iconBgcolor='#217346'
				loading={true}
				buttons={this.getTopMenuBtns()}
				showDropIcon={true}
				dropMenuDatas={this.getDropMenuDatas()}
				onDropMenuClick={e => this.handleMenuClick(e)}
			>
				{this.props.children}
			</WeaTop>
		)

	}
}